Index: trunk/kernel/kern/rpc.h
===================================================================
--- trunk/kernel/kern/rpc.h	(revision 690)
+++ trunk/kernel/kern/rpc.h	(revision 1)
@@ -276,130 +295,225 @@
 void rpc_thread_kernel_create_server( xptr_t xp );
 
-/***********************************************************************************
- * [8] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [9] The RPC_PROCESS_SIGACTION allows a client thread to request a remote cluster
- * to execute a given sigaction, defined by the <action_type> for a given process,
- * identified by the <pid> argument.  When this RPC is used in parallel mode,
- * the rpc_process_sigaction_client() function is not used. 
+/*********************************************************************************** 
+ * The RPC_VFS_INODE_CREATE creates an inode and the associated mapper in a
+ * remote cluster. The parent dentry must have been previously created.
+ * It returns an extended pointer on the created inode.
+ ***********************************************************************************
+ * @ cxy       :  server cluster identifier
+ * @ dentry_xp : [in]  extended pointer on parent dentry.
+ * @ type      : [in]  file system type.
+ * @ attr      : [in]  TODO ???
+ * @ mode      : [in]  access mode.
+ * @ uid       : [in]  user ID
+ * @ gid       : [in]  group ID
+ * @ inode_xp  : [out] buffer for extended pointer on created inode.
+ * @ error     : [out] error status (0 if success).
+ **********************************************************************************/
+void rpc_vfs_inode_create_client( cxy_t      cxy,
+                                  xptr_t     dentry_xp,
+                                  uint32_t   type,
+                                  uint32_t   attr,    
+                                  uint32_t   mode,  
+                                  uint32_t   uid,
+                                  uint32_t   gid,
+                                  xptr_t   * inode_xp,
+                                  error_t  * error );
+
+void rpc_vfs_inode_create_server( xptr_t xp );
+
+/*********************************************************************************** 
+ * The RPC_VFS_INODE_DESTROY releases memory allocated for an inode descriptor
+ * and for the associated mapper in a remote cluster. 
+ ***********************************************************************************
+ * @ cxy       :  server cluster identifier
+ * @ inode     : [in]  local pointer on inode.
+ **********************************************************************************/
+void rpc_vfs_inode_destroy_client( cxy_t                 cxy,
+                                   struct vfs_inode_s * inode );
+
+void rpc_vfs_inode_destroy_server( xptr_t xp );
+
+/*********************************************************************************** 
+ * The RPC_VFS_DENTRY_CREATE creates a dentry in a remote cluster. 
+ * It returns an extended pointer on the created dentry.
+ ***********************************************************************************
+ * @ cxy        :  server cluster identifier
+ * @ type       : [in]  file system type.
+ * @ name       : [in]  directory entry name.
+ * @ parent     : [in]  local pointer on parent inode.
+ * @ dentry_xp  : [out] buffer for extended pointer on created dentry.
+ * @ error      : [out] error status (0 if success).
+ **********************************************************************************/
+void rpc_vfs_dentry_create_client( cxy_t                  cxy,
+                                   uint32_t               type,
+                                   char                 * name,    
+                                   struct vfs_inode_s   * parent,
+                                   xptr_t               * dentry_xp,
+                                   error_t              * error );
+
+void rpc_vfs_dentry_create_server( xptr_t xp );
+
+/*********************************************************************************** 
+ * The RPC_VFS_DENTRY_DESTROY releases memory allocated for an dentry descriptor
+ * in a remote cluster. 
+ ***********************************************************************************
+ * @ cxy       :  server cluster identifier
+ * @ dentry     : [in]  local pointer on dentry.
+ **********************************************************************************/
+void rpc_vfs_dentry_destroy_client( cxy_t                 cxy,
+                                    struct vfs_dentry_s * dentry );
+
+void rpc_vfs_dentry_destroy_server( xptr_t xp );
+
+
+
+
+/***********************************************************************************
+ * The RPC_VMM_GET_REF_VSEG returns an extended pointer 
+ * on the vseg containing a given virtual address in a given process.
+ * The server cluster is supposed to be the reference cluster.
+ * It returns NULL if no vseg has been founded.
  ***********************************************************************************
  * @ cxy     : server cluster identifier.
- * @ pid     : [in] target process identifier.
- * @ action  : [in] sigaction index.
- **********************************************************************************/
-void rpc_process_sigaction_client( cxy_t     cxy,
-                                   pid_t     pid,
-                                   uint32_t  action );
-                             
-void rpc_process_sigaction_server( xptr_t xp );
-
-/*********************************************************************************** 
- * [10] undefined
- **********************************************************************************/
-
-/*********************************************************************************** 
- * [11] undefined
- **********************************************************************************/
-
-/*********************************************************************************** 
- * [12] undefined                                                       
- **********************************************************************************/
-
-/*********************************************************************************** 
- * [13] undefined                                       
- **********************************************************************************/
-
-/***********************************************************************************
- * [14] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [15] The RPC_VMM_RESIZE_VSEG allows a client thread to request a remote cluster
- * to resize a vseg identified by the <base> argument in a process descriptor
- * identified by the <pid> argument, as defined by the <new_base> and <new_size>
- * arguments. Both the VSL and the GPT are updated in the remote cluster. 
- ***********************************************************************************
- * @ cxy         : server cluster identifier.
- * @ pid         : [in] process identifier.
- * @ base        : [in] vseg base.
- * @ new_base    : [in] new vseg base.
- * @ new_size    : [in] new vseg size.
- **********************************************************************************/
-void rpc_vmm_resize_vseg_client( cxy_t              cxy,
-                                 pid_t              pid,
-                                 intptr_t           base,
-                                 intptr_t           new_base,
-                                 intptr_t           new_size );
- 
-void rpc_vmm_resize_vseg_server( xptr_t xp );
-
-/***********************************************************************************
- * [16] The RPC_VMM_REMOVE_VSEG allows a client thread  to request a remote cluster
- * to delete a vseg identified by the <vaddr> argument in a process descriptor
- * identified by the <pid> argument.
- * Both the VSL and the GPT are updated in the remote cluster.
- ***********************************************************************************
- * @ cxy       : server cluster identifier.
- * @ pid       : [in] process identifier.
- * @ base      : [in] vseg base.
- **********************************************************************************/
-void rpc_vmm_remove_vseg_client( cxy_t      cxy,
-                                 pid_t      pid,
-                                 intptr_t   base );
- 
-void rpc_vmm_remove_vseg_server( xptr_t xp );
-
-/***********************************************************************************
- * [17] The RPC_VMM_CREATE_VSEG allows a client thread to request the remote 
- * reference cluster of a given process to allocate and register in the reference
- * process VMM a new vseg descriptor.
- * On the server side, this RPC uses the vmm_create_vseg() function, and returns
- * to the client the local pointer on the created vseg descriptor.
- ***********************************************************************************
- * @ cxy         : server cluster identifier.
- * @ process     : [in]  local pointer on process descriptor in server.
- * @ type        : [in]  vseg type.
- * @ base        : [in]  base address (unused for dynamically allocated vsegs).
- * @ size        : [in]  number of bytes.
- * @ file_offset : [in]  offset in file (for CODE, DATA, FILE types).
- * @ file_size   : [in]  can be smaller than size for DATA type.
- * @ mapper_xp   : [in]  extended pointer on mapper (for CODE, DATA, FILE types).
- * @ vseg_cxy    : [in]  target cluster for mapping (if not data type).
- * @ vseg        : [out] local pointer on vseg descriptor / NULL if failure.
- **********************************************************************************/
-void rpc_vmm_create_vseg_client( cxy_t              cxy,
-                                 struct process_s * process,
-                                 vseg_type_t        type,
-                                 intptr_t           base,
-                                 uint32_t           size,
-                                 uint32_t           file_offset,
-                                 uint32_t           file_size,
-                                 xptr_t             mapper_xp,
-                                 cxy_t              vseg_cxy,
-                                 struct vseg_s   ** vseg );
-
-void rpc_vmm_create_vseg_server( xptr_t xp );
-
-/***********************************************************************************
- * [18] The RPC_VMM_SET_COW allows a client thread to request the remote reference
- * cluster to set the COW flag and reset the WRITABLE flag of all GPT entries for
- * the DATA, MMAP and REMOTE vsegs of process identified by the <process> argument.
-
- * of a remote scheduler, identified by the <lid> argument.
- ***********************************************************************************
- * @ cxy         : server cluster identifier.
- * @ process     : [in]  local pointer on reference process descriptor.
- **********************************************************************************/
-void rpc_vmm_set_cow_client( cxy_t              cxy,
-                             struct process_s * process );
-
-void rpc_vmm_set_cow_server( xptr_t xp );
-
-/***********************************************************************************
- * [19] undefined
- **********************************************************************************/
-
+ * @ process : [in]   pointer on process descriptor in server cluster. 
+ * @ vaddr   : [in]   virtual address to be searched.
+ * @ vseg    : [out]  address of buffer for vseg pointer in client cluster.
+ **********************************************************************************/
+void rpc_vmm_get_ref_vseg_client( cxy_t              cxy,
+                                  struct process_s * process,
+                                  intptr_t           vaddr,
+                                  xptr_t           * vseg_xp );
+
+void rpc_vmm_get_ref_vseg_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_VMM_GET_PTE returns in the "ppn" and "attr" arguments the PTE value
+ * for a given VPN in a given process.
+ * The server cluster is supposed to be the reference cluster, and the vseg
+ * containing the VPN must be registered in the reference VMM.
+ * It returns an error if physical memory cannot be allocated for the PTE2, 
+ * or for the missing page itself.
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier.
+ * @ process : [in]   pointer on process descriptor in server cluster. 
+ * @ vaddr   : [in]   virtual address to be searched.
+ * @ attr    : [out]  address of buffer for attributes.
+ * @ ppn     : [out]  address of buffer for PPN.
+ * @ error   : [out]  address of buffer for error code.
+ **********************************************************************************/
+void rpc_vmm_get_pte_client( cxy_t              cxy,
+                             struct process_s * process,
+                             vpn_t              vpn,
+                             uint32_t         * attr,
+                             ppn_t            * ppn,
+                             error_t          * error );
+
+void rpc_vmm_get_pte_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_SEMAPHORE_ALLOC allocates memory for a semaphore in a remote cluster,
+ * and returns an extended pointer on the created semaphore.
+  It returns NULL if physical memory cannot be allocated. 
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier.
+ * @ sem_xp  : [out] buffer for extended pointer on semaphore. 
+ **********************************************************************************/
+void rpc_semaphore_alloc_client( cxy_t    cxy,
+                                 xptr_t * sem_xp );  
+
+void rpc_semaphore_alloc_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_SEMAPHORE_FREE releases memory allocated for a semaphore 
+ * in a remote cluster.
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier.
+ * @ sem     : [in] local pointer on semaphore. 
+ **********************************************************************************/
+void rpc_semaphore_free_client( cxy_t                 cxy,
+                                struct remote_sem_s * sem );
+
+void rpc_semaphore_free_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_MAPPER_MOVE can be send by any thread running in a "client" cluster 
+ * to the "server" cluster containing the mapper of a given file. The service is 
+ * to move data between the mapper and an user buffer. This user buffer is described
+ * as a set of fragments. Each fragment is contained in one single physical page.
+ * It is defined by four parameters : size / file_offset / ppn / page_offset,
+ * defined in the mapper.h file. The client thread is in charge of building 
+ * the fragments array covering the user buffer. 
+ * As each fragments can be stored in a different cluster, and this fragment can 
+ * be stored in two successive pages in the radix tree, each fragment is moved 
+ * using one or two different hal_remote_memcpy().
+ ***********************************************************************************
+ * @ cxy      : server cluster identifier.
+ * @ inode    : [in]  local pointer on inode (in server cluster).
+ * @ read     : [in]  mapper to buffer if true / buffer to mapper if false.
+ * @ nb_frags : [in]  number of fragments in fragments array.
+ * @ frags    : [in]  local pointer on fragments array (in client cluster).
+ * @ error    : [out] local pointer on buffer for error code (in client cluster). 
+ **********************************************************************************/
+void rpc_mapper_move_client( cxy_t                cxy,
+                             struct mapper_s    * mapper,
+                             bool_t               read,
+                             uint32_t             nb_frags,
+                             struct fragment_s  * frags,
+                             error_t            * error );
+
+void rpc_mapper_move_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_ICU_WTI_ALLOC can be send by any thread running in a "client" cluster
+ * to get a WTI mailbox from the ICU of a "server" cluster.
+ * The WTI is allocated from the server ICU, but the WTI is not enabled,
+ * and no target core is selected in remote cluster.
+ * It returns wti_id == -1 if there is no free WTI in server cluster.
+ ***********************************************************************************
+ * @ cxy      : server cluster identifier.
+ * @ wti_id   : [out] local pointer on WTI index in client cluster (-1 if error).
+ **********************************************************************************/
+void rpc_icu_wti_alloc_client( cxy_t      cxy,
+                               uint32_t * wti_id );    
+
+void rpc_icu_wti_alloc_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_DEVICE_ALLOC can be send by any thread running in a "client" cluster
+ * to create a device descriptor in a remote "server" cluster.
+ * The WTI is allocated from the server ICU, but the WTI is not enabled,
+ * and no target core is selected in remote cluster.
+ * It returns wti_id == -1 if there is no free WTI in server cluster.
+ ***********************************************************************************
+ * @ cxy      : server cluster identifier.
+ * @ dev_xp   : [out] buffer for extended pointer on device (in client cluster).
+ * @ error    : [out] local pointer on buffer for error code (in client cluster). 
+ **********************************************************************************/
+void rpc_device_alloc_client( cxy_t     cxy,
+                              xptr_t  * dev_xp,           
+                              error_t * error );    
+
+void rpc_device_alloc_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_FATFS_GET_CLUSTER can be send by any thread running in a "client" cluster
+ * to scan the FAT mapper, stored in a remote "server" cluster, and get the FATFS 
+ * cluster index of a given page of a given file.
+ ***********************************************************************************
+ * @ cxy      : server cluster identifier.
+ * @ mapper   : [in]  local pointer on FAT mapper.
+ * @ first    : [in]  FATFS cluster index allocated to first page of file.
+ * @ page     : [in]  page index in file.
+ * @ cluster  : [out] local pointer on buffer for found FATFS cluster index.
+ * @ error    : [out] local pointer on buffer for error code (in client cluster). 
+ **********************************************************************************/
+void rpc_fatfs_get_cluster_client( cxy_t             cxy,
+                                   struct mapper_s * mapper,
+                                   uint32_t          first,
+                                   uint32_t          page,
+                                   uint32_t        * cluster,
+                                   error_t         * error );    
+
+void rpc_fatfs_get_cluster_server( xptr_t xp );
 
 #endif
Index: trunk/kernel/kern/rt_timer.h
===================================================================
--- trunk/kernel/kern/rt_timer.h	(revision 1)
+++ trunk/kernel/kern/rt_timer.h	(revision 1)
@@ -0,0 +1,56 @@
+/*
+ * kern/rt_timer.h - real-time timer interface
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef  _RT_TIMER_H_
+#define  _RT_TIMER_H_
+
+#include <types.h>
+
+/** Real-Time timer commands */
+#define RT_TIMER_STOP    0x00
+#define RT_TIMER_RUN     0x01
+#define RT_TIMER_ADJUST  0x02
+
+/** Real-Time timer parameters */
+struct rt_params_s
+{
+	uint_t rt_cmd;
+	sint_t rt_value;
+	void *pv_data;
+};
+
+/** Initialize Real-Time timer source */
+error_t rt_timer_init(uint_t period, uint_t withIrq);
+
+/** Read Real-Time timer current value  */
+error_t rt_timer_read(uint_t *time);
+
+/** Set Real-Time timer's current value */
+error_t rt_timer_set(uint_t time);
+
+/** Set Real-Time timer's period */
+error_t rt_timer_setperiod(uint_t period);
+
+/** Send commands to Real-Time timer device */
+error_t rt_timer_ctrl(struct rt_params_s *param);
+
+#endif	/* _RT_TIMER_H_ */
